Option Explicit
Global erraction As Integer
Global Inst%
Global ret As Variant
Global db As database
Global NewRecordSource As Integer
Global quote As String
Global EndingIt As Integer
Global aiFldSize() As Long       ' Field sizes
 
' API declares for 3d common controls
Declare Function GetModuleUsage Lib "KERNEL" (ByVal InstanceID%) As Integer
Declare Function GetModuleHandle Lib "Kernel" (ByVal ModuleName As String) As Integer
Declare Function Ctl3dAutoSubclass Lib "Ctl3D.DLL" (ByVal hInst As Integer) As Integer
Declare Function Ctl3dRegister Lib "Ctl3D.DLL" (ByVal hInst As Integer) As Integer
Declare Function Ctl3dUnregister Lib "Ctl3D.DLL" (ByVal hInst As Integer) As Integer

Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer

'Note: IniFile should be in Windows Directory

'Example calling Code to create or update ini -------------------------------------------------------------------------------------
    'IniFileName$ = "MyINI.INI"        'name of ini file
    'AppName$ = "MyApp"             'Name of application or section heading
    'KeyName$ = "MyNumber"          'Keyword or variable name
    'NewVal$="MyNewValue"           'if Numeric value convert it to string
    'SaveIni AppName$, IniFileName$, KeyName$, NewVal$

' Example Calling Code to Read Numeric Variable ------------------------------------------------------------------------------
    'IniFileName$ = "MyINI.INI"        'name of ini file
    'AppName$ = "MyApp"             'Name of application or section heading
    'KeyName$ = "MyNumber"          'Keyword or variable name
    'nDefault = 0                   'Default numeric value (for numeric variables)
    'Numeric%=TRUE                  'Tell it we are looking for numeric value
    'ReadIni AppName$, KeyName$, nDefault, DefaultStr$, ReturnStr$, Numeric%, IniFileName$

' Example Calling Code to Read String Variable ------------------------------------------------------------------------------
    'IniFileName$ = "MyINI.INI"        'name of ini file
    'AppName$ = "MyApp"             'Name of application or section heading
    'KeyName$ = "MyString"          'Keyword or variable name
    'DefaultStr$ = "DefaultString"  'Default string        (for String variables)
    'Dim RetStr As String * 255     'Create an empty string to be filled
    'nSize% = 255                   'uncertain - possibly length of fill string
    'Numeric%=FALSE                 'Tell it we are looking for a string
    'ReadIni AppName$, KeyName$, nDefault, DefaultStr$, ReturnStr$, Numeric%, IniFileName$



Sub Cancel3D ()
    ' end the 3D effects
    Inst% = GetModuleHandle(App.EXEName)  ' Get program's ModuleHandle.
    ret = Ctl3dUnregister(Inst%)          ' Unregister the program.

End Sub

Sub EndItNow ()
    On Error Resume Next
    EndingIt = True
    db.Close        ' Close the database
    MainForm.Show MODELESS
    Unload CaptnFrm     ' Unload all possible forms
    Unload DataSpec
    Unload FieldFrm
    Unload GenForm
    
End Sub

Sub ReadIni (AppName$, KeyName$, nDefault, DefaultStr$, ReturnStr$, Numeric%, IniFileName$)
    Dim nSize%, lenRetString%
    
' Read data from Private Profile (.ini) File

    If Numeric% Then    'we are looking for integer input
        Numeric% = GetPrivateProfileInt(AppName$, KeyName$, nDefault, IniFileName$)
    Else
        Dim RetStr As String * 255 'Create an empty string to be filled
        nSize% = 255               'uncertain - possibly length of fill string
        lenRetString% = GetPrivateProfileString(AppName$, KeyName$, DefaultStr$, RetStr$, nSize%, IniFileName$)
        ReturnStr$ = Left$(RetStr$, lenRetString%)
        
    End If


End Sub

Sub SaveIni (AppName$, IniFileName$, KeyName$, NewVal$)
    Dim ResultCode%

    ' Update INI file
        
    ResultCode% = WritePrivateProfileString(AppName$, KeyName$, NewVal$, IniFileName$)
    If ResultCode% = 0 Then
        Beep
        MsgBox "Error updating INI file!", 16, "ERROR!"
    End If


    
End Sub

